
#include <TimedAction.h>
#include "ioConfig.h"
#include "mirror.h"
#include "lcdControl.h"
#include "communication.h"

// void systemRunningLED();

// set pin numbers:
 const int ledPin =  13;      // the number of the LED pin

 // Variables will change:
 int ledState = LOW;             // ledState used to set the LED
 long previousMillis = 0;        // will store last time LED was updated

 // the follow variables is a long because the time, measured in miliseconds,
 // will quickly become a bigger number than can be stored in an int.
 long interval = 200;           // interval at which to blink (milliseconds)

TimedAction readSensorsAction = TimedAction(25, readSensors);
TimedAction lcdPollingAction = TimedAction(150, lcdPolling);

 void setup()
 {
   setupComm();
   calibrateLdrButton();
   setupLcdControl();
 }


 void loop()
 {
   readSensorsAction.check();
   lcdPollingAction.check();
   PowerModingTask();
   //Testing 
   commTask();
   delay(10);
 }


 void systemRunningLED()
 {
     // if the LED is off turn it on and vice-versa:
     if (ledState == LOW)
       ledState = HIGH;
     else
       ledState = LOW;

     // set the LED with the ledState of the variable:
     digitalWrite(ledPin, ledState);
 }
 
 void readSensors()
 {
    ButtonsTask();
    systemRunningLED();
 }
 
 // This function is called peridocalli to detect if
 // any button was pressed
 void lcdPolling()
 {
     lcdTask();
 }
