#include "lcdControl.h"
#include <SimpleMessageSystem.h>

void commTask()
{

  if (messageBuild() > 0)
  { // Checks to see if the message is complete and erases any previous messages
    switch (messageGetChar())
    { // Gets the first word as a character
    case 'b': // Activate the a button from the LCD display
      activateButton(); // Call the readpins function
      break; // Break from the switch
    case 'c': // calibrate
      autoCalibrate();
      break;
    case 'l': // calibrate
      setupLcdControl();
      break;
    case 's': // calibrate
      notificationOfStatus(messageGetInt());
      break;
    }

  }

}

//Setup the communication
void setupComm()
{
   Serial.begin(9600);
}

// Decodes a message to activate the proper button
void activateButton() {
  int data;
  switch (messageGetInt()) { // Gets the next word as a integer

    case POWER_BTN : 
       pressOnOffButton();
    break;  // Break from the switch
    case MENU_BTN : 
       pressMenuButton();
    break; 
    case ANS_BTN :
       pressAnsButton();
    break;
    case SRC_BTN :
       pressSrcButton();
    break; 
    case VOL_PLUS_BTN :
       data = messageGetInt();
       pressVolPlusButton(data);
    break;
    case VOL_MINUS_BTN :
       data = messageGetInt();
       pressVolMinusButton(data);
    break;  
    default : 
       //nothing
    break;
  }
}

// this function executes the required calibrationa
void autoCalibrate() {
   calibrateLdrButton();
 }

