#include <Pulse.h>
#include "lcdControl.h"
#include "ioConfig.h"

#define pulseWidth      50 //ms



// Set the GPIO used to control the LCD
Pulse powerPulseControl(powerControlPin, 3000);  
Pulse menuPulseControl(menuControlPin, pulseWidth);  
Pulse ansPulseControl(ansControlPin, pulseWidth);  
Pulse srcPulseControl(srcControlPin, pulseWidth);  
Pulse volPlusPulseControl(volPlusControlPin, pulseWidth);  
Pulse volMinusPulseControl(volMinusControlPin, pulseWidth);  

void setupLcdControl()
{
   // during the set-up turn on the screen
   pressOnOffButton();
    // Its called twice to set the screen to S-Video
   pressSrcBtutton();
   pressSrcBtutton();
}

void lcdTask()
{
   powerPulseControl.polling();
   menuPulseControl.polling();
   ansPulseControl.polling();
   srcPulseControl.polling();
   volPlusPulseControl.polling();
   volMinusPulseControl.polling();
}

void pressOnOffButton()
{
  powerPulseControl.trigger();
}
void pressMenuButton()
{
  menuPulseControl.trigger();
}

void pressAnsButton()
{
  ansPulseControl.trigger();
}
void pressSrcButton()
{
  srcPulseControl.trigger();
}

void pressVolPlusButton(int num)
{
  volPlusPulseControl.trigger(num);
}
void pressVolMinusButton(int num)
{
  volMinusPulseControl.trigger(num);
}

