#include "AnalogSwitch.h"
#include "powerModing.h"


#define OFF_DELAY   10000


static int currentPowerState = OFF_STATE;
static int newPowerState = STANDBY_STATE;
static int prevPowerState = OFF_STATE;
static unsigned long startTime;
static unsigned long curTime; // this is global variable
unsigned int lightSensorLevel;
boolean goToPrevStateFlag = false;
boolean changeFlag = true;

TimedAction refreshPowerStateAction = TimedAction(750, refreshPowerStatePolling);
AnalogSwitch lightSensor(ldrSensorPort, lightSensorLevel, 0);

 void PowerModingTask()
 {
   switch(currentPowerState)
   {
      case OFF_STATE:
         //Call initialization or any other setup
         offState();
      break;
      case STANDBY_STATE:
         //Call initialization 
         standbyState();
      break;
      case ON_STATE:
         //Call
         standbyState(); 
      break;
   }
   //Update the the current state
   if(newPowerState != currentPowerState)
   {
      currentPowerState = newPowerState;
      //SendNotificationOfStatus(currentPowerState);
   }
   refreshPowerStateAction.check();
 }

 void offState()
 {
   currentPowerState = STANDBY_STATE;
   delay(500);
 }
 
 void standbyState()
 {
     ExecuteDuringStandby();
 }

 void onState()
 {
     ExecuteDuringOn();
 }

 void ExecuteDuringStandby()
 {
   checkLightLevel();
 }
 
 void ExecuteDuringOn()
 {
   //Check the ambient light level
   checkLightLevel();
 
 }
 
 int CurrentPowerState()
 {
    return currentPowerState;
 } 

 void notificationOfStatus(int data)
 {
 }
 
  void refreshPowerStatePolling()
 {
   SendNotificationOfStatus(newPowerState);
 }
 
 void SendNotificationOfStatus(int data)
 {
      messageSendChar('S'); 
      messageSendInt(data);
      messageEnd();
 }
 
 void checkLightLevel()
 {   
      if(lightSensor.Read() && changeFlag)
      {
           #if _DEBUG_MODE_IS
           Serial.println("there is NO light");
           #endif
           prevPowerState = currentPowerState;
           newPowerState = STANDBY_STATE; //Turns off the screen
           goToPrevStateFlag = true;
           changeFlag = false;
      }else
      if(goToPrevStateFlag && !lightSensor.Read())
      {
         #if _DEBUG_MODE_IS
         Serial.println("there is  light");
         #endif
         newPowerState = prevPowerState;
         goToPrevStateFlag = false;
         changeFlag = true;
         SendNotificationOfStatus(newPowerState);
      }
 }


