/* This library allows to contraol an analog input as a simple button. It also
 * handles a threshold to make it more feasable.
 * Author:
 * Efrain Calderon
 * E- mail: darkcerano@gmial.com
 */
#ifndef AnalogSwitch_h
#define AnalogSwitch_h

// library interface description
class AnalogSwitch {
  public:
    // constructors:
    AnalogSwitch(int aPin, int triggerLevel, int threshold);
    // methods
	boolean Read(void);
	void InvertedMode(boolean inverted);
	void SetTriggerLevel(int level);

  private:
    int aPin;                // analog pin number
    int triggerLevel;        // current level
    int threshold;           // threshold size(+/-)
	boolean inverted;        // used to handle the switch as active in low
	boolean state;           // activated/deactivated flag
	void setActive(boolean state); // activate/deactivate
};

#endif

