//Efrain Calderon
// ensure this library description is only included once
#ifndef Pulse_h
#define Pulse_h

// library interface description
class Pulse {
  public:
    // constructors:
    Pulse(int pin, unsigned long ms);
    Pulse(int pin, unsigned long ms, boolean inverted);

    // toggle method:
	void toggle(void);
    void polling(void);
	void setWidth(unsigned long ms);
	void trigger(void);
	void trigger(int n);

    int version(void);

  private:
	void startPulse(void);

    boolean inverted;        // high pulse or low pulse
    boolean active;          // the pulse is active
    boolean wait;            // the pulse is in wait mode
    unsigned long init_time;    // delay between steps, in ms, based on speed
    unsigned long width_ms;     // ms that the puls will last
    unsigned long wait_time;    // delay between steps, in ms, based on speed
    int n_pulses;
    int pulse_pin;
};

#endif

